<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head>
<meta content="text/html; charset=ISO-8859-1" http-equiv="content-type"><title>Tdct Hierarchy Support</title><meta content="Rolf Keitel" name="author"></head>
<body>
<h2><a name="Tdct_Hierarchy_Support">Tdct
Hierarchy Support</a></h2>
<span style="font-weight: bold;">Symbols and Schematics</span><br>
<br>
One of the most powerful features of tdct is the support of
schematic&nbsp;hierarchies with user-designed symbols. Using
expressive
shapes for user-designed symbols greatly enhances the visual
understanding of a schematic's functionality. <br>
<br>
A user-designed symbol&nbsp;represents a user-designed schematic
and
can be used as a "place-holder" for the schematic on another (higher
level) schematic. The symbol may contain macros and ports. Macros pass
parameters
from the higher to the lower level. Ports pass values and
link information in either direction between the hierarchy levels. Each
port on a symbol must correspond to a hierarchical connector with the
same name in the schematic.<br>
<br>
Ports can be simple wire ports or bus-ports, which allow the passing of
multiple values through a single port.<br>
<br>
<span style="font-weight: bold;">Hierarchy<br>
<br>
</span>
Every EPICS run-time database can&nbsp;be presented by the
following
schematic hierarchy:<br>
<ul>
<li>top level: &nbsp;top level schematic</li>
<li>next level: &nbsp;component schematics which are
represented by&nbsp;corresponding component symbol instances on the
next higher
level</li>
<li>.....</li>
<li>bottom component level: primitive component schematics
which contain only
primitive elements</li>
</ul>
In the simplest case, the top level schematic is a primitive component
schematic, no symbols are used and the "hierarchy" contains only one
layer.<br>
tdct does not impose a limit to the number of hierarchy levels.
<br>
<span style="font-weight: bold;"></span><br>
<span style="font-weight: bold;">Primitive elements</span><br>
The primitive elements of the hierarchy are EPICS records,
hierarchical connectors and "hardware I/O". These are represented by
EPICS&nbsp; symbols which are stored in symbol files.&nbsp;A
base library of
EPICS &nbsp;symbols is provided with tdct. This library is easily
extended to include new EPICS records.<br>
<br>
Primitive elements have no associated schematics.<br>
<br>
<span style="font-weight: bold;">Components</span><br>
Components consist of a corresponding schematic/symbol pair. The
component schematic may contain primitive elements and component symbol
instances representing other components. In the
component schematic, macros may be used as placeholders in record
properties or
record names. Hierarchical connectors are used to link EPICS record
fields to the hierarchy level above. The component symbol instances
must instantiate values for the symbol macros. These instance values
may themselves contain macros.<br>
<br>
<span style="font-weight: bold;">Top Level Schematics<br>
</span>Top level schematics are schematics from which EPICS
runtime database are
generated.<br>
<br>
Top level schematics
<ul>
<li>may contain macro definitions</li>
<li>must not contain hierarchical connectors</li>
<li>do not require a
corresponding symbol.&nbsp;</li>
</ul>
<span style="font-weight: bold;">Template Databases</span><br>
If an EPICS runtime database is
generated from a top level schematic which contains unresolved macros,
a template database is created. In this case the macro values must be
instantiated when the template database is loaded into an IOC.<br>
<br>
<span style="font-weight: bold;">Macros and Hierarchy<br>
<br>
</span>In order to maintain backward compatiblity with the
Capfast /
e2db system, macro instance values, once defined on a hierarchy level,
are visible at all lower levels of the hierarchy, even if an
intermediate hierarchy layer does not define the macro.<br>
It is discouraged to use this feature and propagate macros, which are
required in a component schematic, by defining the macro on the
component symbol.
<br>
<br>
<span style="font-weight: bold;">Traversing a Hierarchy<br>
<br>
</span>If a symbol in a schematic is selected, the corresponding
schematic is opened in a new tab by<br>
<ul>
<li>left double-clicking on the selected symbol</li>
<li>pressing the D key</li>
<li>using the <span style="font-style: italic;">File
&gt;&gt; Descend</span> hierarchy &nbsp;menu</li>
</ul>
<br>
<br>
<hr style="width: 100%; height: 2px;">[1]
Phase
Three Logic, Beaverton, Ore., USA
</body></html>